"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loader = void 0;

var _loaderUtils = require("loader-utils");

var _update = require("./update.js");

const validModes = ['lazy', 'lazy-once', 'eager', 'weak'];

const loader = function (source, map, meta) {
  const {
    webpackMode
  } = (0, _loaderUtils.getOptions)(this);
  let replacer = (0, _update.getReplacer)();

  if (webpackMode && validModes.includes(webpackMode)) {
    replacer = (0, _update.getReplacer)({
      webpackMode
    });
  }

  this.callback(null, source.replace(_update.dynamicImportsWithoutComments, replacer), map, meta);
};

exports.loader = loader;